<?php
/**
 * InlineResponse20053Absences
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20053Absences Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20053Absences implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_53_absences';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'ticketId' => 'int',
        'date' => 'int',
        'duration' => 'int',
        'location' => 'string',
        'linkTypeId' => 'int',
        'linkId' => 'int',
        'typeId' => 'int',
        'text' => 'string',
        'durationNotCharged' => 'int',
        'employeeId' => 'int',
        'planningType' => 'object',
        'costCenterId' => 'int',
        'reasonNotChargedText' => 'string',
        'reasonNotChargedId' => 'int',
        'reasonPartialNotChargedId' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'ticketId' => null,
        'date' => 'timestamp',
        'duration' => null,
        'location' => null,
        'linkTypeId' => null,
        'linkId' => null,
        'typeId' => null,
        'text' => null,
        'durationNotCharged' => null,
        'employeeId' => null,
        'planningType' => null,
        'costCenterId' => null,
        'reasonNotChargedText' => null,
        'reasonNotChargedId' => null,
        'reasonPartialNotChargedId' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'ticketId' => 'ticketId',
        'date' => 'date',
        'duration' => 'duration',
        'location' => 'location',
        'linkTypeId' => 'linkTypeId',
        'linkId' => 'linkId',
        'typeId' => 'typeId',
        'text' => 'text',
        'durationNotCharged' => 'durationNotCharged',
        'employeeId' => 'employeeId',
        'planningType' => 'planningType',
        'costCenterId' => 'costCenterId',
        'reasonNotChargedText' => 'reasonNotChargedText',
        'reasonNotChargedId' => 'reasonNotChargedId',
        'reasonPartialNotChargedId' => 'reasonPartialNotChargedId'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'ticketId' => 'setTicketId',
        'date' => 'setDate',
        'duration' => 'setDuration',
        'location' => 'setLocation',
        'linkTypeId' => 'setLinkTypeId',
        'linkId' => 'setLinkId',
        'typeId' => 'setTypeId',
        'text' => 'setText',
        'durationNotCharged' => 'setDurationNotCharged',
        'employeeId' => 'setEmployeeId',
        'planningType' => 'setPlanningType',
        'costCenterId' => 'setCostCenterId',
        'reasonNotChargedText' => 'setReasonNotChargedText',
        'reasonNotChargedId' => 'setReasonNotChargedId',
        'reasonPartialNotChargedId' => 'setReasonPartialNotChargedId'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'ticketId' => 'getTicketId',
        'date' => 'getDate',
        'duration' => 'getDuration',
        'location' => 'getLocation',
        'linkTypeId' => 'getLinkTypeId',
        'linkId' => 'getLinkId',
        'typeId' => 'getTypeId',
        'text' => 'getText',
        'durationNotCharged' => 'getDurationNotCharged',
        'employeeId' => 'getEmployeeId',
        'planningType' => 'getPlanningType',
        'costCenterId' => 'getCostCenterId',
        'reasonNotChargedText' => 'getReasonNotChargedText',
        'reasonNotChargedId' => 'getReasonNotChargedId',
        'reasonPartialNotChargedId' => 'getReasonPartialNotChargedId'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const LOCATION_OFFICE = 'OFFICE';
    public const LOCATION_CUSTOMER = 'CUSTOMER';
    public const LOCATION_REMOTE = 'REMOTE';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getLocationAllowableValues()
    {
        return [
            self::LOCATION_OFFICE,
            self::LOCATION_CUSTOMER,
            self::LOCATION_REMOTE,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['ticketId'] = $data['ticketId'] ?? null;
        $this->container['date'] = $data['date'] ?? null;
        $this->container['duration'] = $data['duration'] ?? null;
        $this->container['location'] = $data['location'] ?? null;
        $this->container['linkTypeId'] = $data['linkTypeId'] ?? null;
        $this->container['linkId'] = $data['linkId'] ?? null;
        $this->container['typeId'] = $data['typeId'] ?? null;
        $this->container['text'] = $data['text'] ?? null;
        $this->container['durationNotCharged'] = $data['durationNotCharged'] ?? null;
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['planningType'] = $data['planningType'] ?? null;
        $this->container['costCenterId'] = $data['costCenterId'] ?? null;
        $this->container['reasonNotChargedText'] = $data['reasonNotChargedText'] ?? null;
        $this->container['reasonNotChargedId'] = $data['reasonNotChargedId'] ?? null;
        $this->container['reasonPartialNotChargedId'] = $data['reasonPartialNotChargedId'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getLocationAllowableValues();
        if (!is_null($this->container['location']) && !in_array($this->container['location'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'location', must be one of '%s'",
                $this->container['location'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of this support
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets ticketId
     *
     * @return int|null
     */
    public function getTicketId()
    {
        return $this->container['ticketId'];
    }

    /**
     * Sets ticketId
     *
     * @param int|null $ticketId id of the connected ticket
     *
     * @return self
     */
    public function setTicketId($ticketId)
    {
        $this->container['ticketId'] = $ticketId;

        return $this;
    }

    /**
     * Gets date
     *
     * @return int|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param int|null $date beginning of the support
     *
     * @return self
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets duration
     *
     * @return int|null
     */
    public function getDuration()
    {
        return $this->container['duration'];
    }

    /**
     * Sets duration
     *
     * @param int|null $duration duration of the service (in minutes)
     *
     * @return self
     */
    public function setDuration($duration)
    {
        $this->container['duration'] = $duration;

        return $this;
    }

    /**
     * Gets location
     *
     * @return string|null
     */
    public function getLocation()
    {
        return $this->container['location'];
    }

    /**
     * Sets location
     *
     * @param string|null $location Defines, where a support takes place
     *
     * @return self
     */
    public function setLocation($location)
    {
        $allowedValues = $this->getLocationAllowableValues();
        if (!is_null($location) && !in_array($location, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'location', must be one of '%s'",
                    $location,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['location'] = $location;

        return $this;
    }

    /**
     * Gets linkTypeId
     *
     * @return int|null
     */
    public function getLinkTypeId()
    {
        return $this->container['linkTypeId'];
    }

    /**
     * Sets linkTypeId
     *
     * @param int|null $linkTypeId link type of the assignment
     *
     * @return self
     */
    public function setLinkTypeId($linkTypeId)
    {
        $this->container['linkTypeId'] = $linkTypeId;

        return $this;
    }

    /**
     * Gets linkId
     *
     * @return int|null
     */
    public function getLinkId()
    {
        return $this->container['linkId'];
    }

    /**
     * Sets linkId
     *
     * @param int|null $linkId id of the assignment
     *
     * @return self
     */
    public function setLinkId($linkId)
    {
        $this->container['linkId'] = $linkId;

        return $this;
    }

    /**
     * Gets typeId
     *
     * @return int|null
     */
    public function getTypeId()
    {
        return $this->container['typeId'];
    }

    /**
     * Sets typeId
     *
     * @param int|null $typeId id of the support type
     *
     * @return self
     */
    public function setTypeId($typeId)
    {
        $this->container['typeId'] = $typeId;

        return $this;
    }

    /**
     * Gets text
     *
     * @return string|null
     */
    public function getText()
    {
        return $this->container['text'];
    }

    /**
     * Sets text
     *
     * @param string|null $text description / text for this support entry
     *
     * @return self
     */
    public function setText($text)
    {
        $this->container['text'] = $text;

        return $this;
    }

    /**
     * Gets durationNotCharged
     *
     * @return int|null
     */
    public function getDurationNotCharged()
    {
        return $this->container['durationNotCharged'];
    }

    /**
     * Sets durationNotCharged
     *
     * @param int|null $durationNotCharged duration which is not charged (in minutes)
     *
     * @return self
     */
    public function setDurationNotCharged($durationNotCharged)
    {
        $this->container['durationNotCharged'] = $durationNotCharged;

        return $this;
    }

    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId id of the employee who has done this support
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets planningType
     *
     * @return object|null
     */
    public function getPlanningType()
    {
        return $this->container['planningType'];
    }

    /**
     * Sets planningType
     *
     * @param object|null $planningType planningType
     *
     * @return self
     */
    public function setPlanningType($planningType)
    {
        $this->container['planningType'] = $planningType;

        return $this;
    }

    /**
     * Gets costCenterId
     *
     * @return int|null
     */
    public function getCostCenterId()
    {
        return $this->container['costCenterId'];
    }

    /**
     * Sets costCenterId
     *
     * @param int|null $costCenterId id of the cost center
     *
     * @return self
     */
    public function setCostCenterId($costCenterId)
    {
        $this->container['costCenterId'] = $costCenterId;

        return $this;
    }

    /**
     * Gets reasonNotChargedText
     *
     * @return string|null
     */
    public function getReasonNotChargedText()
    {
        return $this->container['reasonNotChargedText'];
    }

    /**
     * Sets reasonNotChargedText
     *
     * @param string|null $reasonNotChargedText if support was not chatged, the reason / text goes here
     *
     * @return self
     */
    public function setReasonNotChargedText($reasonNotChargedText)
    {
        $this->container['reasonNotChargedText'] = $reasonNotChargedText;

        return $this;
    }

    /**
     * Gets reasonNotChargedId
     *
     * @return int|null
     */
    public function getReasonNotChargedId()
    {
        return $this->container['reasonNotChargedId'];
    }

    /**
     * Sets reasonNotChargedId
     *
     * @param int|null $reasonNotChargedId id of the \"not charged reason\" (if support was completely not charged)
     *
     * @return self
     */
    public function setReasonNotChargedId($reasonNotChargedId)
    {
        $this->container['reasonNotChargedId'] = $reasonNotChargedId;

        return $this;
    }

    /**
     * Gets reasonPartialNotChargedId
     *
     * @return int|null
     */
    public function getReasonPartialNotChargedId()
    {
        return $this->container['reasonPartialNotChargedId'];
    }

    /**
     * Sets reasonPartialNotChargedId
     *
     * @param int|null $reasonPartialNotChargedId id of the \"not charged reason\" (if support was partially not charged)
     *
     * @return self
     */
    public function setReasonPartialNotChargedId($reasonPartialNotChargedId)
    {
        $this->container['reasonPartialNotChargedId'] = $reasonPartialNotChargedId;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


